module.exports = {
    "parser": "@typescript-eslint/parser",
    "plugins": [
        "@typescript-eslint",
        "simple-import-sort",
        "unused-imports"
    ],
    "extends": [
        "eslint:recommended",
        "plugin:@typescript-eslint/recommended"
    ],
    "rules": {
        "@typescript-eslint/explicit-member-accessibility": [
            "warn",
            {
                "accessibility": "explicit",
                "overrides": {
                    "accessors": "explicit",
                    "constructors": "explicit",
                    "methods": "explicit",
                    "properties": "explicit",
                    "parameterProperties": "explicit"
                }
            }
        ],
        "@typescript-eslint/member-delimiter-style": [
            "error",
            {
                "overrides": {
                    "interface": {
                        "multiline": {
                            "delimiter": "semi",
                            "requireLast": true
                        }
                    },
                    "typeLiteral": {
                        "multiline": {
                            "delimiter": "comma",
                            "requireLast": false
                        }
                    }
                }
            }
        ],
        "@typescript-eslint/no-explicit-any": [
            "warn",
            {}
        ],
        "arrow-parens": [
            "warn",
            "always"
        ],
        "comma-dangle": [
            "error",
            "never"
        ],
        "indent": [
            "warn",
            4,
            { "SwitchCase": 1 }
        ],
        "no-multiple-empty-lines": [
            "error",
            { max: 4, maxBOF: 0, maxEOF: 1 }
        ],
        "no-trailing-spaces": "error",
        "no-useless-escape": "off",
        "prefer-spread": "off",
        "prefer-template": "warn",
        "quotes": [
            "warn",
            "backtick"
        ],
        "semi": [
            "error",
            "always"
        ],
        "simple-import-sort/imports": "error",
        "simple-import-sort/exports": "error",
        "template-curly-spacing": [
            "warn",
            "never"
        ],
        "unused-imports/no-unused-imports": "error",
        "unused-imports/no-unused-vars": [
            "warn",
            { "vars": "all", "varsIgnorePattern": "^_", "args": "after-used", "argsIgnorePattern": "^_" }
        ]
    }
}
